@building-option +create-set-co
@create #2255 named XMPP IQ Disco:XMPP IQ Disco,iq disco,iqd
;_.("key") = 0
;_.("aliases") = {"XMPP IQ Disco", "iq disco", "iqd"}
;_.("offered") = #-1
;_.("object_size") = {1808, 1188288000}
;_.("review_marks") = {}
"_.("review_history") => E_PERM (Permission denied)

@verb _:":handle" this none this
@program _::handle
{children, origin} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
if (children[1][2][1][2] != "http://jabber.org/protocol/disco#info")
  return 0;
endif
infoiq = $local.jabber:new_type_handler("iq");
infoiq.to = origin.from;
infoiq.from = origin.to;
infoiq.id = origin.id;
infoiq.type = "result";
infoiqc1 = infoiq:add_entity("query");
infoiqc1:add_attribute("xmlns", "http://jabber.org/protocol/disco#info");
if (origin.to == $local.jabber.site)
  identity = infoiqc1:add_entity("identity");
  identity:add_attribute("category", "server");
  identity:add_attribute("type", "im");
  identity:add_attribute("name", "MOO Jabber/XMPP");
endif
for feature in (setremove($dict:keys($local.jabber.iq.registry), children[1][2][1][2]))
  featureiq = infoiqc1:add_entity("feature");
  featureiq:add_attribute("var", feature);
endfor
$local.jabber:send(infoiq);
return 1;
.

"***finished***
