@building-option +create-set-co
@create #2255 named XMPP IQ Last:XMPP IQ Last,iqlast
;_.("key") = 0
;_.("aliases") = {"XMPP IQ Last", "iqlast"}
;_.("offered") = #-1
;_.("object_size") = {1674, 1188374415}
;_.("review_marks") = {}
"_.("review_history") => E_PERM (Permission denied)

@verb _:":handle" this none this
@program _::handle
{children, origin} = args;
if ((caller != this) && (!$perm_utils:controls(caller_perms(), this)))
  raise(E_PERM);
endif
feature = $local.jabber.feature;
if (valid(target = feature:is_user(origin.to)))
  if (validsource = feature:_buddy_in_roster(target, origin.from))
    if (feature.options:get(feature:get_jabber_options(target), "last"))
      iq = $local.jabber:new_type_handler("iq");
      iq.to = origin.from;
      iq.from = origin.to;
      iq.id = origin.id;
      iq.type = "result";
      query = iq:add_entity("query");
      query:add_attribute(@children[1][2][1]);
      if (target in connected_players())
        query:add_attribute("seconds", tostr(idle_seconds(target)));
      endif
      $local.jabber:send(iq);
      return 1;
    endif
  endif
endif
origin:error(children, 503);
return 1;
.

"***finished***
